# $Revision: 1.52 $, $Date: 2012/06/27 08:50:42 $
# TODO
# - cleanup dead links from /etc/openssl/certs after -update uninstall
# - https://bugzilla.mozilla.org/show_bug.cgi?id=549701 and
#   http://groups.google.com/group/mozilla.dev.security.policy/browse_thread/thread/b6493a285ba79998#
# - add certs noted in TODO file
#
Summary:	Common CA Certificates PEM files
Summary(pl.UTF-8):	Pliki PEM popularnych certyfikatów CA
Name:		ca-certificates
Version:	20120623
Release:	1
License:	GPL v2 (scripts), MPL v2 (mozilla certs), distributable (other certs)
Group:		Libraries
Source0:	ftp://ftp.debian.org/debian/pool/main/c/ca-certificates/%{name}_%{version}.tar.gz
# Source0-md5:	5105d4cc086f0d4ecf7bf2e4c4667289
Source1:	https://www.verisign.com/support/thawte-roots.zip
# Source1-md5:	a3709cc0279ef3fca4f86ea775066b18
Source2:	http://www.certum.pl/keys/CA.pem
# Source2-md5:	35610177afc9c64e70f1ce62c1885496
Source3:	http://www.certum.pl/keys/level1.pem
# Source3-md5:	ba2d2e234ef9cfd2e6e5f810c964862e
Source4:	http://www.certum.pl/keys/level2.pem
# Source4-md5:	d06578a04e8cb23071f3870430ea0cf0
Source5:	http://www.certum.pl/keys/level3.pem
# Source5-md5:	47b67c63a52236576fc0d1150327c962
Source6:	http://www.certum.pl/keys/level4.pem
# Source6-md5:	f1f8a65d177745311a1e99f029ae5d71
Source7:	http://www.certum.pl/keys/vs.pem
# Source7-md5:	8da19ffc48c5dcc2868b1aa55f1d5983
Source8:	http://www.certum.pl/keys/na.pem
# Source8-md5:	ba571cb35e7672ff7ae95132ac1bfec4
Source9:	http://www.certum.pl/keys/tsa.pem
# Source9-md5:	1a7b3faf8ed00f4d80297de74862e102
Source10:	http://www.certum.pl/keys/class1.pem
# Source10-md5:	058436b132ea2df6972821f546104a16
Source11:	http://www.certum.pl/keys/class2.pem
# Source11-md5:	5caf7fe99b1fc6e63c40b3d081711d1b
Source12:	http://www.certum.pl/keys/class3.pem
# Source12-md5:	07bc97e21da092ba53535c7379e1b58b
Source13:	http://www.certum.pl/keys/class4.pem
# Source13-md5:	99ef61d509539af89f1c025b67245965
Source14:	http://crt.tcs.terena.org/TERENASSLCA.crt
# Source14-md5:	f62cd1546a8ef14e31ba1ce8eecd234a
Source15:	http://crt.tcs.terena.org/TERENAeScienceSSLCA.crt
# Source15-md5:	5feea35ab01a373f115219706f1f57bd
Source16:	http://crt.tcs.terena.org/TERENAPersonalCA.crt
# Source16-md5:	53eaa497c8fb0b79f14fe9f69693689a
Source17:	http://crt.tcs.terena.org/TERENAeSciencePersonalCA.crt
# Source17-md5:	e25cc655d3ebe920ca9c187e3dde9191
Source18:	http://crt.tcs.terena.org/TERENACodeSigningCA.crt
# Source18-md5:	74c9f511ab03a4e6b7462e310abfa89b
Source19:	http://www.sk.ee/upload/files/JUUR-SK.PEM.cer
# Source19-md5:	805784c06c9eff3771a4b9bd631cd3f5
Source20:	http://www.sk.ee/upload/files/ESTEID-SK.PEM.cer
# Source20-md5:	387beee5b8539ab7d91628f486295899
Source21:	http://www.sk.ee/upload/files/ESTEID-SK%202007.PEM.cer#/ESTEID-SK_2007.PEM.cer
# Source21-md5:	2b1a2a77f565d68fdf5f19f6cc3a5600
Source22:	http://www.sk.ee/upload/files/ESTEID-SK%202011.pem.cer#/ESTEID-SK_2011.pem.cer
# Source22-md5:	cfcc1e592cb0ff305158a7e32730546c
Patch0:		%{name}-undebianize.patch
Patch1:		%{name}-more-certs.patch
Patch2:		%{name}-etc-certs.patch
Patch3:		%{name}-c_rehash.sh.patch
Patch4:		%{name}-endline.patch
Patch5:		%{name}-DESTDIR.patch
Patch6:		%{name}.d.patch
URL:		http://www.cacert.org/
BuildRequires:	openssl-tools
BuildRequires:	python
BuildRequires:	python-modules
BuildRequires:	rpm >= 4.4.9-56
BuildRequires:	sed >= 4.0
BuildRequires:	unzip
Obsoletes:	certificates
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		certsdir	/etc/certs
%if "%{pld_release}" == "th"
%define		openssldir	/etc/openssl/certs
%else
%define		openssldir	/var/lib/openssl/certs
%endif

%description
Common CA Certificates PEM files.

%description -l pl.UTF-8
Pliki PEM popularnych certyfikatów CA.

%package update
Summary:	Script for updating CA Certificates database
Summary(pl.UTF-8):	Skrypt do odświeżania bazy certyfikatów CA
Group:		Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	mktemp
%if "%{pld_release}" == "ac"
Requires:	openssl-tools >= 0.9.7m-2
%else
Requires:	openssl-tools >= 0.9.8i-3
%endif

%description update
Script and data for updating CA Certificates database.

%description update -l pl.UTF-8
Skrypt i dane do odświeżania bazy certyfikatów CA.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

%{__sed} -i -e 's,@openssldir@,%{openssldir},' sbin/update-ca-certificates*

%{__unzip} -qq %{SOURCE1} -d thawte

find thawte/ -name *.pem -o -name *.txt| while read f ; do
	if (file "$f" | grep -q "PEM"); then
		ff=$(echo $f | sed -e 's|[ ,]|_|g' -e 's|[()]|=|g')
		nname=$(basename "$ff" .pem)
		nname=$(basename "$nname" .txt)
		nname=$(basename "$nname" _b64)
		cp -pi "$f" "thawte/${nname}.crt"
	else
		echo "Skipping $f, doesn't look like PEM CERT"
	fi
done

install -d certum
cp -pi %{SOURCE2} certum
cp -pi %{SOURCE3} certum
cp -pi %{SOURCE4} certum
cp -pi %{SOURCE5} certum
cp -pi %{SOURCE6} certum
cp -pi %{SOURCE7} certum
cp -pi %{SOURCE8} certum
cp -pi %{SOURCE9} certum
cp -pi %{SOURCE10} certum
cp -pi %{SOURCE11} certum
cp -pi %{SOURCE12} certum
cp -pi %{SOURCE13} certum
for a in certum/*.pem; do
	mv -i "$a" "${a%.pem}.crt"
done

install -d terena
openssl x509 -inform DER -in %{SOURCE14} -outform PEM -out terena/$(basename %{SOURCE14})
openssl x509 -inform DER -in %{SOURCE15} -outform PEM -out terena/$(basename %{SOURCE15})
openssl x509 -inform DER -in %{SOURCE16} -outform PEM -out terena/$(basename %{SOURCE16})
openssl x509 -inform DER -in %{SOURCE17} -outform PEM -out terena/$(basename %{SOURCE17})
openssl x509 -inform DER -in %{SOURCE18} -outform PEM -out terena/$(basename %{SOURCE18})

# http://www.sk.ee/en/Repository/certs/rootcertificates
# JUUR-SK, ESTEID-SK and ESTEID-SK 2007, ESTEID-SK 2011
install -d esteid
cp -pi %{SOURCE19} esteid
cp -pi %{SOURCE20} esteid
cp -pi %{SOURCE21} esteid/ESTEID-SK_2007.crt
cp -pi %{SOURCE22} esteid/ESTEID-SK_2011.crt
for a in esteid/*.PEM.cer; do
	mv -i "$a" "${a%.PEM.cer}.crt"
done

%build
%{__make}

# We have those and more in specific dirs
rm mozilla/{Thawte,thawte,Certum,IGC_A,Deutsche_Telekom_Root_CA_2,Juur-SK}*.crt

# See TODO
# rm mozilla/RSA_Security_1024_v3.crt

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_datadir}/%{name},%{_sbindir},%{certsdir},%{_sysconfdir}/ca-certificates.d}
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

find $RPM_BUILD_ROOT%{_datadir}/ca-certificates -name '*.crt' -exec sed -i -e 's/\r$//' {} \;

(
cd $RPM_BUILD_ROOT%{_datadir}/ca-certificates
find . -name '*.crt' | sort | cut -b3-
) > $RPM_BUILD_ROOT%{_sysconfdir}/ca-certificates.conf

# build %{certsdir}/ca-certificates.crt
install -d $RPM_BUILD_ROOT%{openssldir}
./sbin/update-ca-certificates --destdir $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_ROOT%{openssldir}

%clean
rm -rf $RPM_BUILD_ROOT

%post update
%{_sbindir}/update-ca-certificates --fresh || :

%files
%defattr(644,root,root,755)
%doc debian/README.Debian debian/changelog
%config(noreplace) %verify(not md5 mtime size) %{certsdir}/ca-certificates.crt

%files update
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/update-ca-certificates
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/ca-certificates.conf
%dir %{_sysconfdir}/ca-certificates.d
%{_datadir}/ca-certificates

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: ca-certificates.spec,v $
Revision 1.52  2012/06/27 08:50:42  glen
- update to 20120623
- mozilla certs changed license to MPL-2.0
- mozilla/certdata.txt updated to version 1.81:
  Certificates added (+) and removed (-):
  + "Security Communication RootCA2"
  + "EC-ACC"
  + "Hellenic Academic and Research Institutions RootCA 2011"
  - "Verisign Class 2 Public Primary Certification Authority"
  - "Verisign Class 4 Public Primary Certification Authority - G2"
  - "TC TrustCenter, Germany, Class 2 CA"
  - "TC TrustCenter, Germany, Class 3 CA"

Revision 1.51  2012/05/12 13:35:36  baggins
- rel 2
- current version already contains all certs from mozilla

Revision 1.50  2012/05/12 13:15:57  glen
- add /etc/ca-certificates.d to support local certs, so there won't be need to edit package version of /etc/ca-certificates.conf, and thus no .rpmnew merge need

Revision 1.49  2012/05/12 12:59:54  glen
- up to 20120212, see changelog for added/removed ca-s

Revision 1.48  2011/09/05 13:25:17  jajcus
- Version: 20110502+nmu1 - blacklisted a compromised "DigiNotar Root CA" certificate

Revision 1.47  2011/08/30 12:08:20  glen
- up to 20110502 (no changes to certs)

Revision 1.46  2011/08/27 12:26:54  glen
- add amsn bundled certs todo

Revision 1.45  2011/07/07 09:32:59  glen
- some merge tool needed for /etc/ca-certificates.conf

Revision 1.44  2011/06/11 09:06:58  glen
- Juur-SK included by mozilla as well

Revision 1.43  2011/06/11 08:58:13  glen
- preserve timestamps

Revision 1.42  2011/05/23 07:26:35  arekm
- up to 20110421

Revision 1.41  2011/03/30 17:58:35  arekm
- 14; use files without spaces for distfiles

Revision 1.40  2011/03/30 15:39:57  arekm
- rel 13; fix thawte certs; force interactive mode for cp/mv (so we know if overwrittes happen)

Revision 1.39  2011/03/27 09:44:32  arekm
- rel 12; fix sk.ee certs; add sk.ee ESTEID 2011

Revision 1.38  2011/03/27 09:32:22  arekm
- rel 11; update to nmu3 tarball; update external certs

Revision 1.37  2010/05/18 10:26:06  glen
- df space problem hack

Revision 1.36  2010/05/18 10:11:14  glen
- cross distro compat (ac and likely ti as well); rel 10

Revision 1.35  2010/05/06 06:43:28  arekm
- rel 9; revert; no hashes in main pkg

Revision 1.34  2010/05/06 06:40:38  arekm
- rel 8; force new openssl since mixing ca-certificates with hashes from old openssl with new openssl library (and vice versa) is asking for trouble

Revision 1.33  2010/05/06 06:37:27  arekm
- rel 7

Revision 1.32  2010/05/05 11:18:58  glen
- use same method for generating /etc/certs/ca-certificates.crt at package build time
- %20 vs space fix workaround

Revision 1.31  2010/05/05 10:40:03  glen
- add esteid certs, www.sk.ee

Revision 1.30  2010/04/06 15:17:33  baggins
- added TODO about RSA Security 1024 V3 root CA

Revision 1.29  2010/03/23 12:16:53  baggins
- rel 6
- added TERENA CA, https://www.terena.org/
- updated mozilla bundle from nss-3.12.5
- avoid making duplicate .pem ext in update-ca-certificates script

Revision 1.28  2010/02/24 11:53:30  baggins
- rel 5
- certificate file may not end with newline, take that into account when
  generating ca-certificates.crt in install

Revision 1.27  2010/02/09 14:38:48  baggins
- rel 4
- convert newlines of all files from DOS to UNIX in install
- fix for missing newline at end of file

Revision 1.26  2010/02/09 14:16:16  baggins
- rel 3
- make update-ca-certificates create bundle in proper place

Revision 1.25  2010/02/04 14:27:03  arekm
- release 2

Revision 1.24  2010/02/01 22:29:46  sparky
- BR: python-modules

Revision 1.23  2010/02/01 14:34:10  baggins
- TODO is still valid, I should read more slowly and carefully

Revision 1.22  2010/02/01 13:51:30  baggins
- TODO done

Revision 1.21  2010/02/01 13:24:59  baggins
- updated to 20090814

Revision 1.20  2009/03/28 12:07:58  arekm
- up to 20081127

Revision 1.19  2008/11/17 20:55:21  glen
- mktemp is -update pkg dep, base pkg is still a plain single file; rel 5

Revision 1.18  2008/11/11 18:40:56  glen
- ca-certificates doesn't require openssl (anymore)

Revision 1.17  2008/11/09 18:26:09  glen
- todo about trash in /etc/openssl/certs

Revision 1.16  2008/11/09 18:23:10  glen
- use /etc/certs/ca-certificates.crt for for ca bundle path; rel 4

Revision 1.15  2008/11/03 16:12:41  glen
- use shell constructs

Revision 1.14  2008/11/03 16:08:22  glen
- internal deps should be strict, unless reasoned otherwise

Revision 1.13  2008/11/03 14:05:32  baggins
- rel 3
- move script and source certs to -update package
- main package no longer requires openssl-tools*

Revision 1.12  2008/11/01 18:35:42  baggins
- rel 2

Revision 1.11  2008/11/01 18:33:49  baggins
- R: rpm-whiteout >= 1.7

Revision 1.10  2008/11/01 18:29:28  baggins
- strict R on openssl*

Revision 1.9  2008/11/01 18:22:04  baggins
- rel 1
- allow placing ca certs also in /etc/certs
- use /etc/openssl for symlinks and stuff

Revision 1.8  2008/11/01 12:16:10  baggins
- added Certum and Thawte bundles for certificates.spec
- obsolete certificates
- BR unzip, ruby
- build certs from mozilla bundle

Revision 1.7  2008/11/01 11:21:13  baggins
- use global /etc/certs dir
- removed Debian run-parts

Revision 1.6  2008/10/29 08:44:43  glen
- there can be only one!

Revision 1.5  2008/10/28 00:14:03  glen
- add /etc/ca-certificates/update.d dir

Revision 1.4  2008/10/28 00:10:51  glen
- updated to 20080809

Revision 1.3  2007/04/29 16:27:32  qboosh
- pl

Revision 1.2  2007/04/23 23:29:30  glen
- c_rehash is in openssl-tools-perl

Revision 1.1  2007/04/23 23:18:12  glen
- new (based on gentoo ebuild)
